<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInventoryPricingEntry ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfInventoryPricingEntry
 * @subpackage Arrays
 */
class ArrayOfInventoryPricingEntry extends AbstractStructArrayBase
{
    /**
     * The InventoryPricingEntry
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\InventoryPricingEntry[]
     */
    public $InventoryPricingEntry;
    /**
     * Constructor method for ArrayOfInventoryPricingEntry
     * @uses ArrayOfInventoryPricingEntry::setInventoryPricingEntry()
     * @param \patest\StructType\InventoryPricingEntry[] $inventoryPricingEntry
     */
    public function __construct(array $inventoryPricingEntry = array())
    {
        $this
            ->setInventoryPricingEntry($inventoryPricingEntry);
    }
    /**
     * Get InventoryPricingEntry value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\InventoryPricingEntry[]|null
     */
    public function getInventoryPricingEntry()
    {
        return isset($this->InventoryPricingEntry) ? $this->InventoryPricingEntry : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInventoryPricingEntry method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInventoryPricingEntry method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInventoryPricingEntryForArrayConstraintsFromSetInventoryPricingEntry(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInventoryPricingEntryInventoryPricingEntryItem) {
            // validation for constraint: itemType
            if (!$arrayOfInventoryPricingEntryInventoryPricingEntryItem instanceof \patest\StructType\InventoryPricingEntry) {
                $invalidValues[] = is_object($arrayOfInventoryPricingEntryInventoryPricingEntryItem) ? get_class($arrayOfInventoryPricingEntryInventoryPricingEntryItem) : sprintf('%s(%s)', gettype($arrayOfInventoryPricingEntryInventoryPricingEntryItem), var_export($arrayOfInventoryPricingEntryInventoryPricingEntryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InventoryPricingEntry property can only contain items of type \patest\StructType\InventoryPricingEntry, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InventoryPricingEntry value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\InventoryPricingEntry[] $inventoryPricingEntry
     * @return \patest\ArrayType\ArrayOfInventoryPricingEntry
     */
    public function setInventoryPricingEntry(array $inventoryPricingEntry = array())
    {
        // validation for constraint: array
        if ('' !== ($inventoryPricingEntryArrayErrorMessage = self::validateInventoryPricingEntryForArrayConstraintsFromSetInventoryPricingEntry($inventoryPricingEntry))) {
            throw new \InvalidArgumentException($inventoryPricingEntryArrayErrorMessage, __LINE__);
        }
        if (is_null($inventoryPricingEntry) || (is_array($inventoryPricingEntry) && empty($inventoryPricingEntry))) {
            unset($this->InventoryPricingEntry);
        } else {
            $this->InventoryPricingEntry = $inventoryPricingEntry;
        }
        return $this;
    }
    /**
     * Add item to InventoryPricingEntry value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\InventoryPricingEntry $item
     * @return \patest\ArrayType\ArrayOfInventoryPricingEntry
     */
    public function addToInventoryPricingEntry(\patest\StructType\InventoryPricingEntry $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\InventoryPricingEntry) {
            throw new \InvalidArgumentException(sprintf('The InventoryPricingEntry property can only contain items of type \patest\StructType\InventoryPricingEntry, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InventoryPricingEntry[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\InventoryPricingEntry|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\InventoryPricingEntry|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\InventoryPricingEntry|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\InventoryPricingEntry|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\InventoryPricingEntry|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InventoryPricingEntry
     */
    public function getAttributeName()
    {
        return 'InventoryPricingEntry';
    }
}
